require("player")
require("map")
require("debug")
STI = require("libraries/sti")
camera = require("libraries/camera")


function love.load()
    cam = camera()

    Map:load()
    Player:load()
end

function love.update(dt)
    local mouseX = love.mouse.getX()
    local mouseY = love.mouse.getY()
    World:update(dt)
    Map:camera()
    Player:update(dt)
    cam:lookAt(Player.x, Player.y)

end  
 
function love.draw()

    cam:attach()
    Map.level:drawLayer(Map.level.layers["wall"])

        Player:draw()
    cam:detach()

    love.graphics.reset()
    love.graphics.setColor(255,255,255)
    love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 0)
    love.graphics.print("X = "..Player.x.." Y = "..Player.y,10,25)
    love.graphics.print("Radian = "..Player.radian,10,50)

    local mouseX = love.mouse.getX()
    local mouseY = love.mouse.getY()
    love.graphics.print("MouseX = "..mouseX,10,75)
    love.graphics.print("MouseY = "..mouseY,10,100)
    love.graphics.print("camX = "..cam.x,1000,0)
    love.graphics.print("camX = "..cam.y,1000,25)
    local w = love.graphics.getWidth()
	local h = love.graphics.getHeight()
    love.graphics.print("w = "..w.."("..(w/2)..")" ,1000,50)
    love.graphics.print("h = "..h.."("..(h/2)..")",1000,75)
    local mapW = Map.level.width * Map.level.tilewidth
	local mapH = Map.level.height * Map.level.tileheight
    love.graphics.print("mapW = "..mapW.."("..(mapW - w/2)..")" ,1000,100)
    love.graphics.print("mapH = "..mapH.."("..(mapW - h/2)..")",1000,125)
end

function love.keypressed(key)
    if key == "escape" then
       love.event.quit()
    end
end

function beginContact(a,b,scollision)
    if Player:beginContact(a,b,collision) then return end
end

function endContact(a,b,collision)
    Player:endContact(a,b,collision)
end