Map = {}

function beginContact(a, b, collision)
	-- https://love2d.org/wiki/Contact
	local x1, y1, x2, y2 = collision:getPositions()
	local textA = a:getUserData()
	local textB = b:getUserData()
	
	--print ("beginContact", textA, textB)
	if #World:getContacts( ) == 1 then
		--test = 'begin contact: ' .. textA .. ' to ' .. textB
	else
		--test = test .. '\n' .. 'begin contact: ' .. textA .. ' to ' .. textB
	end
	
end

function endContact(a,b,collision)
	-- https://love2d.org/wiki/Contact
	local x, y = collision:getNormal()
	local textA = a:getUserData()
	local textB = b:getUserData()
	
	--test = test .. '\n' .. "end contact: " .. textA .. ' to ' .. textB
	local contacts = World:getContacts( )
	if #contacts == 1 then -- the last one
		--test = "no contacts"
	end
	for i, contact in ipairs (contacts) do
		local fixtureA, fixtureB =  contact:getFixtures( )
		print ('contact '..i, fixtureA:getUserData(), fixtureB:getUserData())
	end
end

function Map:load()
	self.currentLevel = 1
	-- https://love2d.org/wiki/World
	World = love.physics.newWorld(0,0)
	World:setCallbacks(beginContact, endContact)	
	self:init()
end

function Map:init()
	self.level = STI("Levels/Level"..self.currentLevel..".lua", {"box2d"})
	self.level:box2d_init(World)
	--self.level.layers.solid.visible = true
	self.spawnEntities()
end

function Map:next()
	self:clean()
	self.currentLevel = 2
	self:init()
end

function Map:clean()
	self.level:box2d_removeLayer("solid")
	self.level:box2d_removeLayer("entity")
end

function Map:spawnEntities()
	
end

function Map:camera()
	local w = love.graphics.getWidth()
	local h = love.graphics.getHeight()

	
	--Left
	if cam.x < w/2 then
		cam.x = w/2
	end
	--Top
	if cam.y < h/2 then
		cam.y = h/2
	end

	local mapW = self.level.width * self.level.tilewidth
	local mapH = self.level.height * self.level.tileheight

	--Right
	if  cam.x > (mapW - w/2) then
		cam.x = (mapW - w/2)
	end

	if  cam.y > (mapH - h/2) then
		cam.y = (mapH - h/2)
	end
end


return Map