Player = {}

function Player:load()
    self.x = 200      
    self.xVector = math.ceil((self.x/64))
    self.xVel = 0
    self.yVel = 0
    self.y = 515
    self.yVector = math.ceil((self.y/64))
    self.Health = 75
    self.MaxHealth = 100
    self.ShieldHealth = 75
    self.ShieldMaxHealth = 100
    self.isAlive = true
    self.baseTimer = 0
    self.seconds = 0
    --self.playerFront = love.graphics.newImage("assets/playerFront.png")
   -- self.playerBack = love.graphics.newImage("assets/playerBack.png")
    self.playerRight = love.graphics.newImage("assets/playerRight.png")
    self.playerLeft = love.graphics.newImage("assets/playerLeft.png")
    self.degres = 0.0174532925199432957

    self.width = self.playerRight:getWidth()
    self.height = self.playerRight:getHeight()
    self.pointerX = self.x + 18
    self.pointerY = self.y + 7
    self.isContact = false
    self.MaxSpeed = 200
    self.Friction = 3500
    self.Acceleration = 3000
    self.pointerWidth = 15
    self.pointerHeight = 15
    self.mouseX, self.mouseY = love.mouse.getPosition()
    self.isDown = false
    
    self.distanceX = love.mouse.getX() - self.pointerX
    self.distanceY = love.mouse.getY() - self.pointerY
    self.distanceNumber = 40
    self.distance = math.min(math.sqrt(self.distanceX^2 + self.distanceY^2), self.distanceNumber)
    self.angle = math.atan2(self.distanceY, self.distanceX)
    self.radian = self.angle/self.degres

    self.pupilX = self.pointerX + (math.cos(self.angle) * self.distance)
    self.pupilY = self.pointerY + (math.sin(self.angle) * self.distance)

    self.physics = {}
    self.physics.body = love.physics.newBody(World,self.x,self.y,"dynamic")
    self.physics.shape = love.physics.newRectangleShape(self.width, self.height)
    self.physics.fixture = love.physics.newFixture(self.physics.body,self.physics.shape)
    self.physics.fixture:setCategory(2)
    self.physics.fixture:setMask(2)  
    
    self.physics.body:setFixedRotation(true)

    --self.physics.fixture:setSensor(true)
    self.firstContact = true

end

function Player:update(dt)
    self.mouseX, self.mouseY = love.mouse.getPosition()
    self.physics.body:setLinearVelocity(self.xVel,self.yVel)
    self.x, self.y = self.physics.body:getPosition()
    
    --MOVEMENT
    if love.keyboard.isDown("d", "right") then
        if self.xVel < self.MaxSpeed then
            if self.xVel + self.Acceleration < self.MaxSpeed then
                self.xVel = self.xVel + self.Acceleration 
            else
                self.xVel = self.MaxSpeed
            end 
        end 
    elseif love.keyboard.isDown("a","left")  then
        if self.xVel > -self.MaxSpeed then
            if self.xVel - self.Acceleration > -self.MaxSpeed then
                self.xVel = self.xVel - self.Acceleration 
            else
                 self.xVel = -self.MaxSpeed
            end 
        end
    else
        if self.xVel > 0 then
            if self.xVel - self.Friction * dt > 0 then
                self.xVel = self.xVel - self.Friction * dt
            else
                self.xVel = 0
            end
         elseif self.xVel < 0 then
            if self.xVel + self.Friction * dt < 0 then
                self.xVel = self.xVel + self.Friction * dt
            else
                self.xVel = 0
            end
        end 
    end

    if love.keyboard.isDown("s", "down") then
        if self.yVel < self.MaxSpeed then
            if self.yVel + self.Acceleration < self.MaxSpeed then
                self.yVel = self.yVel + self.Acceleration 
            else
                self.yVel = self.MaxSpeed
            end 
        end 
    elseif love.keyboard.isDown("w","up")  then
        if self.yVel > -self.MaxSpeed then
            if self.yVel - self.Acceleration > -self.MaxSpeed then
                self.yVel = self.yVel - self.Acceleration 
            else
                 self.yVel = -self.MaxSpeed
            end 
        end
    else
        if self.yVel > 0 then
            if self.yVel - self.Friction * dt > 0 then
                self.yVel = self.yVel - self.Friction * dt
            else
                self.yVel = 0
            end
         elseif self.yVel < 0 then
            if self.yVel + self.Friction * dt < 0 then
                self.yVel = self.yVel + self.Friction * dt
            else
                self.yVel = 0
            end
        end 
    end

end

function Player:draw()
     --self.pointerX = love.graphics.getWidth() / 2 
   -- self.pointerY = love.graphics.getHeight() / 2 
    self.pointerX = self.x + 20
	self.pointerY = self.y + 5
    self.distanceX = love.mouse.getX() - self.pointerX
    self.distanceY = love.mouse.getY() - self.pointerY    
    self.distance = math.min(math.sqrt(self.distanceX^2 + self.distanceY^2), self.distanceNumber)
    self.angle = math.atan2(self.distanceY, self.distanceX)
    self.radian = self.angle/self.degres
    
    
    self.pupilX = self.pointerX + (math.cos(self.angle) * self.distance)
    self.pupilY = self.pointerY + (math.sin(self.angle) * self.distance)

    --if degres > -125 and degres <= -70 then
        --love.graphics.draw(self.playerBack,self.x,self.y,0,1,1,32,60)
    if self.radian > -105 and self.radian <= 120 then -- original > -70 and <= 60
        love.graphics.draw(self.playerRight,self.x,self.y,0,1,1,32,60)
    elseif self.radian > 120 and self.radian <= 180 or self.radian <= -105 and self.radian >= -180 then -- original > 143 and <= 180 or <=125 and >=-180
        love.graphics.draw(self.playerLeft,self.x,self.y,0,1,1,32,60)
    --elseif degres > 60 and degres <= 143  then
        --love.graphics.draw(self.playerFront,self.x,self.y,0,1,1,32,60)
    end




    love.graphics.polygon("line", self.physics.body:getWorldPoints(self.physics.shape:getPoints()))    
    love.graphics.rectangle("fill",self.pupilX-32,self.pupilY-32,self.pointerWidth,self.pointerHeight)
  
end

